---
workflow:
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
      variables:
        CI_COMMIT_BRANCH: $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME
    - if: $CI_COMMIT_BRANCH && $CI_OPEN_MERGE_REQUESTS
      when: never
    - if: $CI_COMMIT_BRANCH
    - if: $CI_COMMIT_TAG
      when: never
    # Filters out chore releases
    - if: $CI_COMMIT_MESSAGE =~ /^chore\(release\).*/
      when: never
    - when: always

include:
  - template: Jobs/Dependency-Scanning.gitlab-ci.yml
  - template: Jobs/SAST.gitlab-ci.yml
  - template: Jobs/Secret-Detection.gitlab-ci.yml

  # See https://gitlab.com/hoppr/hoppr-security-policy-project for security and licensing policies

  - local: .gitlab/ci/*.yml

# Global SAST Variables
variables:
  SAST_EXCLUDED_PATHS: spec,test,tests,tmp,node_modules,target,venv
  SAST_BANDIT_EXCLUDED_PATHS: "*/test/**,*/tests/**,*/node_modules/**,*/target/**,*/venv/**"
  SECRET_DETECTION_EXCLUDED_PATHS: docs

  ## Semantic Release
  ENABLE_SEMANTIC_RELEASE: "true"
  ENABLE_SEMANTIC_RELEASE_DRY_RUN: "true"

  FORCE_INTEGRATION_TESTS: "false"
  RUNNER_GENERATE_ARTIFACTS_METADATA: "true"

default:
  artifacts:
    name: $CI_JOB_ID
    paths:
      - ${ARTIFACT_NAME}-metadata.json
  tags:
    - saas-linux-large-amd64

stages:
  - pre
  - build
  - check
  - test
  - docs
  - deploy
  - publish

gemnasium-python-dependency_scanning:
  stage: check
  needs: []

semgrep-sast:
  stage: check
  needs: []

secret_detection:
  stage: check
  needs: []
